import {
  
  geoPath,
  colorValue,
  colorScale,
  geoNaturalEarth1,

} from 'd3';

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);


export const choroplethMap = (selection, props) => {
  const {                      
  	features,
    colorScale,
    colorValue,
    svg,
    zoom,
    selectedColor
    
  } = props; 
  
 const gUpdate = selection.selectAll('d').data([null]
                                       )
 const gEnter = gUpdate.enter().append('g')
 
 const g = gUpdate.merge(gEnter)
 
	gEnter
    .append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}))
  	.merge(gUpdate.select('.sphere'))
    .attr('opacity', () => selectedColor ? 0.05 : 1)
	svg.call(zoom().on('zoom', () => {
  	g.attr('transform', event.transform);
}));
  
 const paths = g.selectAll('.country').data(features, d => d.id)
   const pathsEnter = paths.enter().append('path')
      .attr('class', 'country').attr('d', pathGenerator)
   pathsEnter
  .merge(paths).attr('opacity',d => !selectedColor || colorValue(d) === selectedColor ?
                    1 : 0.2)
      
      .attr('fill', d => colorScale(colorValue(d)))
    
     pathsEnter.append('title')
      .text(d => d.properties.name + ': ' + colorValue(d));
}