import {
  select,
  zoom,
  event,
  scaleOrdinal,
  schemeSpectral
} from 'd3';
import { loadAndProcessData } from './loadAndProcessData';
import { colorLegend } from './colorLegend';
import { choroplethMap } from './ChoroplethMap'

const svg = select('svg');

const g = svg.append('g');


const colorScale = scaleOrdinal();

const ChoroplethMapG = svg.append('g')

  const colorLegendG = svg.append('g')
    .attr('transform', `translate(40,310)`);

// const colorValue = d => d.properties.income_grp;
const colorValue = d => d.properties.economy;

let selectedColor 
let features

const onClick = d => {
  selectedColor = d
  render()
}

loadAndProcessData().then(countries => {
  features = countries.features
  render() 
});

const render = () => {
    
  colorScale
    .domain(features.map(colorValue))
    .domain(colorScale.domain().sort().reverse())
    .range(schemeSpectral[colorScale.domain().length]);
  
  colorLegendG.call(colorLegend, {
    colorScale,
    circleRadius: 8,
    spacing: 20,
    textOffset: 12,
    backgroundRectWidth: 235,
    onClick,
    selectedColor
  });
 ChoroplethMapG.call(choroplethMap, {
 features,
   colorScale, 
   colorValue,
   svg,
   zoom,
   selectedColor,
   
 }); 
}
